
'------------------------------  #include <mega32.h> ---------------------------
$regfile = "m32def.dat"
$crystal = 11059200
'$crystal = 4000000
$baud = 9600
'--------------------------- #include <lcd.h> ----------------------------------
Config Lcd = 16 * 2
Config Lcdpin = Pin , Db4 = Portb.4 , Db5 = Portb.5 , Db6 = Portb.6 , _
Db7 = Portb.7 , Rs = Portb.0 , E = Portb.2
'----------------------------  #include <keypad.h> -----------------------------
'Config Kbd = Portb

' char buffer[64];
 'float SP=50,temp,error,last_error,last_iterm,kp=.025,ki=.0000075,kd=1;
' float pterm,iterm,dterm,D;
'unsigned int  D2,LD,HD;

Dim Setpoint As Byte , Temp As Single , Error As Single , Last_error As Single
Dim Last_iterm As Single , Kp As Single , Ki As Single , Kd As Single
Dim Pterm As Single , Iterm As Single , Dterm As Single , D As Single
Dim D2 As Word , Lowd As Word , Highd As Word , A As Word , B As Single , C As Word , E As Word
Setpoint = 80
Kp = 0.020                                                  '0.025
Ki = 0.0000075
Kd = 1
C = 0
E = 0
'--------   interrupt [EXT_INT0] void ext_int0_isr(void)      ------------------
'Config Single = Scientific , Digits = 7
Config Timer2 = Pwm , Pwm = On , Compare Pwm = Clear Up , Prescale = 64

'-----------   interrupt [ADC_INT] void adc_isr(void)---------------------------
Config Adc = Single , Prescaler = Auto , Reference = Avcc
' Config Adc = Single , Prescaler = Auto , Reference = Internal
 Start Adc
Enable Interrupts

'-------------------------------------------------------------------------------



Do

'----------------------------    get tempreture   ------------------------------
A = Getadc(0)
B = A / 200
Temp = B * 100
'---------------------------  while(1) -----------------------------------------

            Error = Setpoint - Temp
            Pterm = Kp * Error
            Iterm = Ki * Error
            Iterm = Iterm + Last_iterm
            Dterm = Error - Last_error
            Dterm = Dterm * Kd
            D = Pterm + Iterm
            D = D + Dterm
            D = D * 100
            If D < 1 Then
            D = 1
            End If
            If D > 1020 Then
            D = 1020
            End If
            Last_iterm = Iterm
            Last_error = Error
            D2 = D
            Highd = D2 / 256                                'change to int val [xx xx]
            Lowd = D2 Mod 256

'-----------------   sprintf(temp,SP,pterm,iterm,dterm)   ----------------------
'Ocr2 = D
C = C + 1
E = C Mod 2
If E = 0 Then
Ocr2 = Highd                                                'D
Else
Ocr2 = Lowd                                                 ' - Highd
End If
'-------------------------------------------------------------------------------
                                                    'Lowd - Highd'D2
Locate 1 , 1 : Lcd Temp
'Locate 1 , 1 : Lcd D
Locate 2 , 1 : Lcd "KP= " : Lcd Pterm
Locate 3 , 1 : Lcd "KI= " : Lcd Iterm
Locate 4 , 1 : Lcd "KD= " : Lcd Dterm


 Loop
 End
